-- Monad transformers
-- Author :: Ulf Norell
-- Created:: 2004-12-16

-- # import Monad

MonadTransformerLaws :
    (T : (Set -> Set) -> Set -> Set)                ->
    ((M : Set -> Set) -> MonadOps M -> MonadOps (T M))   ->
    ((M : Set -> Set) -> MonadOps M -> (A : Set) -> M A -> T M A)  ->
    Type
MonadTransformerLaws T monadOps lift = sig
  monadLaws   : (M : Set -> Set) -> (monadM : Monad M) ->
                  MonadLaws (T M) (monadOps M monadM.ops).return
                                  (monadOps M monadM.ops).bind
  liftReturn : (M : Set -> Set) -> (monadM : Monad M) ->
                  (A : Set) -> (x : A) ->
                  let returnM   = monadM.ops.return A
                      returnTM  = (monadOps M monadM.ops).return A
                      lift      = lift M monadM.ops A
                  in
                    lift (returnM x) == returnTM x
  liftBind    : (M : Set -> Set) -> (monadM : Monad M) ->
                  (A, B : Set) -> (m : M A) -> (k : A -> M B) ->
                  let (>>=)     = monadM.ops.bind A B
                      (>>=')    = (monadOps M monadM.ops).bind A B
                      liftA     = lift M monadM.ops A
                      liftB     = lift M monadM.ops B
                  in
                    liftB (m >>= k) == (liftA m >>=' \x -> liftB (k x))
  

MonadTransformerOps : (T : (Set -> Set) -> Set -> Set) -> Type
MonadTransformerOps T = sig
  monad  : (M : Set -> Set) -> MonadOps M -> MonadOps (T M)
  lift   : (M : Set -> Set) -> MonadOps M -> (A : Set) -> M A -> T M A
  

MonadTransformer : (T : (Set -> Set) -> Set -> Set) -> Type
MonadTransformer T = sig
  ops    : MonadTransformerOps T
  proofs : MonadTransformerLaws T ops.monad ops.lift

transformMonad :
    (T : (Set -> Set) -> Set -> Set) -> MonadTransformer T ->
    (M : Set -> Set)                  -> Monad M ->
    Monad (T M)
transformMonad T transT M monadM = struct
  ops    = transT.ops.monad M monadM.ops
  proofs = transT.proofs.monadLaws M monadM
