-- "Impredicative" Encoding of 1,0,*,Nat,forall,exists

-- Unit type

Id : Type 
Id = (A:Set) -> A -> A

id : Id 
id = \A -> \x -> x

-- Empty type

Empty : Type 
Empty = (A:Set) -> A

abort : (C:Set) -> Empty -> C
abort = \C -> \bot -> bot C

-- Cartesian product

Prod : Set -> Set -> Type
Prod = \A -> \B -> (X:Set) -> (A -> B -> X) -> X

pair : (A:Set) -> (B:Set) -> A -> B -> Prod A B
pair = \A -> \B -> \a -> \b -> \X -> \f -> f a b

fst : (A:Set) -> (B:Set) -> Prod A B -> A
fst = \A -> \B -> \p -> p A (\a -> \b -> a)

snd : (A:Set) -> (B:Set) -> Prod A B -> B
snd = \A -> \B -> \p -> p B (\a -> \b -> b)

-- Natural numbers

Nat : Type
Nat = (X:Set) -> (X -> X) -> X -> X

zero : Nat 
zero = \X -> \s -> \z -> z

succ : Nat -> Nat 
succ = \n -> \X -> \s -> \z -> s (n X s z)

natIter : Nat -> (A:Set) -> A -> (A -> A) -> A
natIter = \n -> \A -> \z -> \s -> n A s z

-- Quantifiers

ForAll : (A:Set) -> (A -> Set) -> Type
ForAll = \A -> \B -> (x:A) -> B x

forAllElim : (A:Set) -> (B:A -> Set) -> ForAll A B -> (x:A) -> B x
forAllElim = \A -> \B -> \p -> \x -> p x

Exist : (A:Set) -> (A -> Set) -> Type
Exist = \A -> \B -> (X:Set) -> ((x:A) -> B x -> X) -> X

existIntro : (A:Set) -> (B:A -> Set) -> (x:A) -> B x -> Exist A B
existIntro = \A -> \C -> \y -> \b -> \X -> \f -> f y b


